
#include "global.h"

void Usage(void)
{
printf("\n"
       "\n"
       " htdump [options] [http[s]://][[username]:[password]@]<server>[:port][path]\n"
       "\n"
       "\n"
       " DESCRIPTION\n"
       " ===================================\n"
       " htdump is an automation utility to retrieve URLs and write them\n"
       " to a file or process them through a pipline. This is also a very\n"
       " usefull tool for web developer who work low level, for example\n"
       " with CGI binaries. This makes a perfect debugging tool, since it\n"
       " allows usual but also rfc-illegal operations. Packet level\n"
       " debugging is included in this tool.\n"
       "\n"
       " htdump supports SSL (via OpenSSL if included during compile time)\n"
       " by using 'https://' at the beginning of the requested URL, SSL is\n"
       " turned on, and port 443 is presumed, although port can still be\n"
       " changed. Otherwise SSL is off, and port 80 is presumed.\n"
       "\n"
       " Username and password (basic authentication) is supported and can\n"
       " be entered with the URL. Empty username or password is allowed.\n"
       "\n"
       " To get more verbosity, give the -d option once. Twice will show\n"
       " packets as they arrive in hexadecimal format.\n"
       "\n"
       " Form data posting is allowed with the -P option. The data is send\n"
       " as x-www-form-urlencoded data (standard with form data). The length\n"
       " is automatically calculated and taken up in the headers. Use the -d\n"
       " option to examine what exactly gets send. Using the -P option\n"
       " overrides a -c option.\n"
       "\n"
       " The HTML protocol can either be 'raw' (without any version info\n"
       " transmitted) or version 1.0 or 1.1. Please note that some www\n"
       " servers react badly to raw requests. Also some options can only\n"
       " be used with the 1.1 protocol version. If contacting a server\n"
       " that is virtual hosting, select -v 1 and also the -h option.\n"
       "\n"
       "\n"
       " OPTIONS\n"
       " ===================================\n"
       " Main mode of operation:\n"
       " -C <command>       Define request command   (default is GET)\n"
       " -P <data>          POST form data\n"
       "\n"
       " Miscellaneous:\n"
       " -d                 Debug mode, only show headers\n"
       " -dd                Debug mode, show all packets\n"
       " -e                 Escape the given URL (@) (default is off)\n"
       " -f <output file>   Dump data to file.       (default is stdout)\n"
       "\n"
       " Header adjustment:\n"
       " -a <accept>        Add 'Accept:' header\n"
       " -c <data>          Add 'Cookie:' header\n"
       " -F <email>         Add 'From:' header\n"
       " -h <host>          Add 'Host:' header   (*)\n"
       " -r <referer>       Add 'Referer:' header\n"
       " -R <range>         Add 'Range:' header  (*)\n"
       " -u <user agent>    Add 'User-Agent:' header\n"
       " -v <0|1|r>         Select HTTP version      (default HTTP/1.0)\n"
       "\n"
       " (*) = HTTP/1.1 only\n"
       " (@) = Not implemented yet\n"
       " You need to give -v 0 or -v 1 to use password authentication\n"
       "\n"
       "\n"
       " EXAMPLES\n"
       " ===================================\n"
       " htdump http://www.netscape.com/\n"
       " htdump http://flemming:secret@www.jamesbond.com/members/secret.html\n"
       " htdump -v 1 -h www.vhost1.com http://127.0.0.1/\n"
       " htdump -v 1 -r www.fbi.gov http://www.arpa.mil/secret.zip\n"
       " htdump -v r -u \"Crazy www browser 1.6\" http://bouncy.com/\n"
       " htdump -c OPTIONS http://arak.cs.hro.nl/ -d -v 1\n"
       " htdump -f this.zip http://download.com/this.zip &\n"
       " htdump http://download.com/big.zip -v 1 -R 644221- >> big.zip &\n"
       " htdump -P \"name=Ren&op1=yes\" http://here.com/cgi-bin/prog\n"
       "\n"
       "\n"
       " htdump "VERSION"\n"
       " Copyright Ren Hoek (ren@arak.cs.hro.nl)\n"
       " Distributed under an Artistic License.\n"
       " Homepage: http://arak.cs.hro.nl/~ren/linux/\n"
       "\n"
      );
exit(6);
}      
